using System;
using Jypeli;



namespace Harjoitustyöpeli;

/// @author teamakin & kotam
/// @version 21.03.2025
/// <summary>
/// Korttipeli, jossa arvataan onko kortti isompi vai pienempi
/// </summary>
public class Harjoitustyöpeli : PhysicsGame
{
    // käytetään uuden kortin luomiseen
    private Kortti _uusiKortti;
   // käytetään nykyisen kortin luomiseen
    private Kortti _nykyinenKortti;
  // käytetään pistelaskurin luomiseen
    private IntMeter _pisteet;
    public override void Begin()
    {
        // kutsuu pelikentän
        LuoKentta();
        // asettaa peliin ohjaimet, jotka ovat nuolinäppäimet ylös ja alas
        AsetaOhjaimet();
        // LisääLaskurit lisää peliin pistelaskurin
        LisaaLaskurit();

        //luo ensimmäisen kortin?
        _nykyinenKortti = new Kortti(50, 100,RandomKone());
        Add(_nykyinenKortti);
        
        //antaa kortille arvon ja laittaa sen labeliksi korttiin näkyville
        Label korttiarvo = new Label(_nykyinenKortti.Lukuarvo.ToString());
        _nykyinenKortti.Add(korttiarvo);
              
        _uusiKortti = new Kortti(50, 100, RandomKone()); // arpoo seuraavan kortin jota verrataan nykyiseen
    }
 
    
///author @kotam
/// version 3.4.2025 
/// <summary>
/// RandomKone arpoo arvon väliltä 1-13, koneen avulla saadaan arvottua nykyisen kortin arvo, mutta myös kortin allaolevan kortin arvo. 
/// </summary>
/// <returns>palauttaa int arvon väliltä 1-13</returns>
    public int RandomKone()
    {
        Random rng = new Random();
        int luku = rng.Next(1, 14);
        return luku; //palauttaa arvotun int arvon väliltä 1-13
    }
    
    /// author @teamakin
    /// <summary>
    /// ohjelma antaa pelikentälle värin :)
    /// </summary>
    public void LuoKentta()
    {
        Level.BackgroundColor = Color.SeaGreen;
    }

   
   ///@author kotam
   /// version 3.4.2025
   /// <summary>
   /// funktio luo pistelaskurin ja määrittää maksimipisteet
   /// </summary> 
  public IntMeter LuoPisteLaskuri(double x, double y)
  {
        IntMeter laskuri = new IntMeter(0);
        laskuri.MaxValue = 52;
        Label naytto = new Label();
        naytto.BindTo(laskuri);
        naytto.X = x;
        naytto.Y = y;
        naytto.TextColor = Color.White;
        naytto.BorderColor = Level.Background.Color;
        naytto.Color = Level.Background.Color;
        Add(naytto);
        
        return laskuri;
    }

   
  /// author @teamakin
  /// <summary>
  /// ohjelma lisää pistelaskurin näkyville
  /// </summary>
    public void LisaaLaskurit() //lisää peliin pistelaskurin
    {
        _pisteet = LuoPisteLaskuri(Screen.Left + 100.0, Screen.Top - 100.0);
    }

  
    ///@author kotam
    /// version 3.4.2025
    /// <summary>
   /// aloittaa pelin alusta kutsuttaessa, laittaa peli alkuasemiin
   /// </summary>
    public void AloitaAlusta()
    {
        ClearAll(); //tyhjentää pelikentän
        LuoKentta(); // luo pelikentän ja lisää värin
        LisaaLaskurit(); // lisää pistelaskurin
        AsetaOhjaimet(); // lisää peliohjaimet

        //arpoo uuden nykyisen kortin ja lisää sille arvot 
        _nykyinenKortti = new Kortti(50, 100, RandomKone());
        Add(_nykyinenKortti); // lisää kortin näytölle
        Label korttiarvo = new Label(_nykyinenKortti.Lukuarvo.ToString());
        _nykyinenKortti.Add(korttiarvo); // Lisää kortin arvon näkyviin
    }

    
///author @teamakin
/// <summary>
/// Ohjelma tarkistaa onko seuraava kortti suurempi. 
/// Jos on, lisää pisteen ja arvotaan uusi kortti.
/// </summary>
    public void Suurempi()
    {
        if (_uusiKortti == null) // tarkistaa onko uusikortti arvoltaan tyhjä
        {
            _uusiKortti = new Kortti(50, 100, RandomKone()); // jos uusi kortti on arvoltaan tyhjä, arvotaan uudestaan
        }
        
        if (_uusiKortti.Lukuarvo > _nykyinenKortti.Lukuarvo) // mikäli arvataan uuden kortin olevan suurempi, ja uusikortti on suurempi kuin nykyinen
        {

            _nykyinenKortti.Destroy(); // Poista vanha kortti
            _nykyinenKortti = _uusiKortti; // Asettaa uuden kortin nykyiseksi
            _uusiKortti = new Kortti(50, 100, RandomKone()); // Luo uusi kortti
            Add(_nykyinenKortti); //lisää nykyisen kortin 
            Label korttiarvo = new Label(_nykyinenKortti.Lukuarvo.ToString()); 
            _nykyinenKortti.Add(korttiarvo); // lisää kortin arvon näytölle

            _pisteet.Value += 1; // lisää yhden pisteen
        }

        
        // jos arvaus on väärä niin tausta vaihtuu punaiseksi
        // ja kehottaa aloittamaan alusta
        else
        {
            
        Level.BackgroundColor = Color.Red; // muuttaa pelin taustavärin punaiseksi

        Label uudestaan = new Label("Ota huikka! paina R aloittaaksesi alusta" ); //antaa ohjeet miten peli aloitetaan alusta
        uudestaan.X = Screen.Right - 500;
        uudestaan.Y = Screen.Bottom + 100;
        Add(uudestaan); //lisää ohjeet näytölle
        }
    }


    ///@author kotam
    /// version 3.4.2025
    /// <summary>
    /// tarkistaa onko seuraava kortti pienempi kuin nykyinen
    /// jos on, lisää pisteen ja arpoo uuden kortin
    /// </summary>
public void Pienempi()
{
    //tarkistaa onko uusikortti arvoltaan tyhjä
    if (_uusiKortti == null)
    {
        _uusiKortti = new Kortti(50, 100, RandomKone()); // jos uusikortti on tyhjä arvotaan uudestaan
    }
    
    if (_uusiKortti.Lukuarvo < _nykyinenKortti.Lukuarvo)
    {
        // Poistaa vanhan kortin
        _nykyinenKortti.Destroy();
        // Vaihtaa nykyisen kortin uudeksi
        _nykyinenKortti = _uusiKortti;
        // Luo uuden UusiKortti jatkoa varten
        _uusiKortti = new Kortti(50, 100, RandomKone());
        Add(_nykyinenKortti); // lisää nykyisen kortin
        Label korttiarvo = new Label(_nykyinenKortti.Lukuarvo.ToString());
        _nykyinenKortti.Add(korttiarvo); // lisää nykyisen kortin arvon näytölle
        
        _pisteet.Value += 1; // lisää yhden pisteen
    }
    
    
    // jos arvaus on väärä niin tausta vaihtuu punaiseksi
    // ja kehottaa aloittamaan alusta
    else
    {
        Level.BackgroundColor = Color.Red;
        Label uudestaan = new Label("Ota Huikka! paina R aloittaaksesi alusta!");  // kertoo ohjeet
        uudestaan.X = Screen.Right - 500;
        uudestaan.Y = Screen.Bottom + 100;
        Add(uudestaan); //lisää tekstin näytölle
    }
}
 
    
    /// author @temakin
    /// <summary>
    /// Määrittää ohjaimet: nuoli ylös (suurempi) ja nuoli alas (pienempi).
    /// Escape-painikkeella voi lopettaa pelin.
    /// </summary>
    void AsetaOhjaimet()
    {
        Keyboard.Listen(Key.Up, ButtonState.Released, Suurempi, "suurempi"); // antaa nuoli ylös näppäimelle suurempifunktiokutsun
        Keyboard.Listen(Key.Down, ButtonState.Released, Pienempi, "pienempi"); // antaa nuoli alas näppäimelle pienempifunktiokutsun
        Keyboard.Listen(Key.Escape, ButtonState.Pressed, ConfirmExit, "Lopeta peli"); //antaa esc näppäimelle funktion lopeta peli
        Keyboard.Listen(Key.R, ButtonState.Released, AloitaAlusta, "Aloita peli alusta"); // antaa r näppäimelle aloita alusta funktiokutsun
    }
}


///@author kotam
/// version 3.4.2025
/// <summary>
/// Korttiluokka, joka sisältää kortin ominaisuudet (koko ja arvo).
/// </summary>
class Kortti : PhysicsObject
{
    //annetaan kortille ominaisuus lukuarvo
    //public string Maa;
    public int Lukuarvo; // Kortin arvo (1-13)
    
    /// <summary>
    /// Kortin konstruktori, joka määrittelee kortin koon ja arvon.
    /// </summary>
    public Kortti(double leveys, double korkeus, int lukuarvo): base (leveys, korkeus)
    {
        this.Lukuarvo = lukuarvo;
    }
}